<template>
  <v-sheet
    append
    v-show="formExpensesStores"
    v-model="formExpensesStores"
    class="ma-5"
  >
    <v-card>
      <v-card-title>
        <v-toolbar-title>{{ title }}</v-toolbar-title>
        <v-spacer />
        <v-btn icon @click="formExpensesStores = !formExpensesStores">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-card-title>
      <hr
        role="separator"
        aria-orientation="horizontal"
        class="v-divider theme--light"
      />
      <form>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  v-model="editedItem.name"
                  label="ชื่อร้านค้า"
                  required
                  :error-messages="nameErrors"
                  @input="$v.editedItem.name.$touch()"
                  @blur="$v.editedItem.name.$touch()"
                >
                </v-text-field>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  v-model="editedItem.detail"
                  label="รายละเอียด"
                  required
                  :error-messages="detailErrors"
                  @input="$v.editedItem.detail.$touch()"
                  @blur="$v.editedItem.detail.$touch()"
                ></v-text-field>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  clearable
                  v-model="editedItem.location"
                  label="สถานที่ตั้ง"
                  type="text"
                
                >
                  <!-- <template v-slot:append-outer>
                    <v-btn small>
                      <v-icon dark> mdi-image-plus </v-icon>
                    </v-btn>
                  </template> -->
                </v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer />
          <v-btn color="light-blue darken-2" dark>Clear</v-btn>
          <v-btn :color="btnCollo" dark @click="handdleAddData">
            {{ title }}
          </v-btn>
        </v-card-actions>
      </form>
    </v-card>
  </v-sheet>
</template>
<script>
import { validationMixin } from 'vuelidate'
import {
  required,
  minLength,
  maxLength,
  email,
  integer,
} from 'vuelidate/lib/validators'

import Swal from 'sweetalert2'

import { mapState, mapActions, mapGetters } from 'vuex'

import getExpenses from '~/mixins/getExpenses'

export default {
  mixins: [validationMixin, getExpenses],
  validations: {
    editedItem: {
      name: {required},
      detail: {required},   
      location: { required },
    },
  },

  props: ['findLastID', 'itemUnit'],

  data: () => ({
    btnCollo: 'success',
    indexEdit: -1,
    date: new Date().toISOString().substr(0, 10),
    search: null,
    editedItem: {
      id: null,
      name: '',
      detail: '',
      location: '',
      auth: '',
    },
    objExpensetype: '', //รับค่า Object จาก Selecter
    defaultItem: {
      id: null,
      name: '',
      detail: '',
      location: '',
      auth: '',
    },
  }),
  beforeCreate() {},
  watch: {
    // getExpensesUnit() {
    //   this.unitExpenses = this.dataExpensesUnit
    // },
  },
  computed: {
    // ...mapState({
    //   unitExpensess: (store) => store.expensesunit.ExpensesUnit,
    // }),
    // validate
    nameErrors() {
      const errors = []
      if (!this.$v.editedItem.name.$dirty) return errors
      !this.$v.editedItem.name.required && errors.push('กรุณากรอกชื่อร้าน')
      return errors
    },
    detailErrors() {
      const errors = []
      if (!this.$v.editedItem.detail.$dirty) return errors
      !this.$v.editedItem.detail.required && errors.push('กรุณากรอกรายละเอียดที่อยู่')
      return errors
    },
    formExpensesStores: {
      get() {
        return this.$nuxt.$store.state.expensesstores.formExpensesStores
      },
      set(newVal) {
        this.$store.commit('SET_FORM_EXPENSES_STORES', newVal)
      },
    },
    title() {
      this.indexEdit = this.$nuxt.$store.state.expensesstores.EditItem
      // this.typeExpenseslist = this.itemList
      // this.unitExpenses = this.itemUnit
      if (this.indexEdit === -1) {
        //เพิ่ม 2 (AddForm) การจัดการข้อความ "เพิ่มข้อมูล", ข้อความปุ่ม, สีปุ่ม
        this.btnCollo = 'success'
        // this.putFormadddata()
        return 'เพิ่มข้อมูล'
      } else {
        //แก้ไข 2 (AddForm) การจัดการข้อความ "เพิ่มข้อมูล", ข้อความปุ่ม, สีปุ่ม
        this.putFormeditdata()
        this.btnCollo = 'warning'
        return 'แก้ไขข้อมูล'
      }
    },
  },
  mounted() {},
  methods: {
    customFilter(item, queryText, itemText) {
      const textOne = item.name.toLowerCase()
      const textTwo = item.detail.toLowerCase()
      const searchText = queryText.toLowerCase()
      return (
        textOne.indexOf(searchText) > -1 || textTwo.indexOf(searchText) > -1
      )
    },
    remove(item) {
      const index = this.editedItem.listExpenses.name.indexOf(item  )
      if (index > 0) this.editedItem.listExpenses.name.splice(index, 1)
      else this.editedItem.listExpenses = ''
    },
    putFormadddata() {
      //เพิ่ม 2.1 (AddForm) Set editItem ให้เป็นค่าว่าง พร้อมสำหรับกรอกข้อมูล
      this.editedItem = Object.assign({}, this.defaultItem)
    },
    putFormeditdata() {
      //แก้ไข 2.1 (AddForm) Set editItem จาก Parameter ที่ Commit เข้าใน Store จากนั้น ดึงค่าจาก Store โดยตรงมาใช้
      this.editedItem = Object.assign(
        {},
        this.$nuxt.$store.state.expensesstores.EditData
      )
      this.editedItem
    },
    handdleAddData() {
      //เพิ่ม 2.2 (AddForm) Click เพิ่ม
      this.editedItem.auth = this.$nuxt.$store.state.users.user.email

      //ตรวจสอบการ Input ค่า ครบ,ถูก
      this.$v.$touch()
      if (this.$v.$invalid) {
        console.log('กรอกข้อมูลไม่ถูกต้อง หรือ ไม่ครบ')
      } else {
        if (this.indexEdit === -1) {
          // indexEdit != 1 (เพิ่ม)
          //เพิ่ม 2.3 (AddForm) Input ค่า ID, Email เข้าไปใน Edititem
          this.editedItem.id = this.$nuxt.$store.state.expensesstores.StoresID
          
          //เพิ่ม 2.4 (AddForm) dispatch ไปยัง Fnc เพิ่มข้อมูล
          this.$store
            .dispatch('addDataexpensesStores', {
              formVal: this.editedItem,
              // selectVal: this.objExpensetype,
            })
            .then(() => {
              // เคลียร์ค่าว่าง
              this.editedItem = Object.assign({}, this.defaultItem)

              const Toast = Swal.mixin({
                toast: true,
                position: 'top',
                showConfirmButton: false,
                timer: 2000,
                timerProgressBar: true,
                didOpen: (toast) => {
                  toast.addEventListener('mouseenter', Swal.stopTimer)
                  toast.addEventListener('mouseleave', Swal.resumeTimer)
                },
              })

              Toast.fire({
                icon: 'success',
                title: 'บันทึกข้อมูลสำเร็จ',
              })

              //เพิ่ม 2.4.1 (AddForm) Set Commit จัดการหน้า Form สำหรับเพิ่มข้อมูล
              this.$store.commit('SET_FORM_EXPENSES_STORES', false)
            })
            .catch((error) => {
              setTimeout(() => {
                console.log('Error In Cilent:', error.code)
              }, 2000)
            })
        } else {
          // indexEdit == 1 (แก้ไข)
          Swal.fire({
            title: 'คุณแน่ใจหรือไม่',
            text: 'คุณต้องการแก้ไขข้อมูลนี้',
            icon: 'question',
            showCancelButton: true,
            confirmButtonColor: '#FB8C00',
            cancelButtonColor: '#0288D1',
            confirmButtonText: 'ใช่, แก้ไขข้อมูล',
            cancelButtonText: 'ยกเลิก',
          }).then((result) => {
            if (result.isConfirmed) {
              Swal.fire(
                'แก้ไขข้อมูล',
                'คุณได้แก้ไขข้อมูลเรียบร้อยแล้ว',
                'success'
              )
              //แก้ไข 2.2 (AddForm) dispatch พร้อม parameter "this.editItem" ไปยัง Fnc เพิ่มข้อมูล
              this.$store
                .dispatch('editDataExpensesStores', { formVal: this.editedItem })
                .then(() => {
                  //แก้ไข 2.2.1 (AddForm) Assign ค่าว่างเปล่าให้กับ "this.editemItem"
                  this.editedItem = Object.assign({}, this.defaultItem)
                  //แก้ไข 2.2.2 (AddForm) Set Commit จัดการหน้า Form สำหรับแก่ไขข้อมูล
                  this.$store.commit('SET_FORM_EXPENSES_STORES', false)
                })
            }
          })
        }
        
      }
    },
  },
}
</script>
<style scoped>
.v-input {
  width: 100%;
}
</style>
